#!/bin/sh

ksmroot=${ksmroot:-"/adds/kbmenu"}

if [ $( lsof | grep -c [[:space:]]/mnt/onboard/ ) -gt 0 ]; then
  $ksmroot/kbmessage.sh "/mnt/onboard/ is busy"
  exit
fi

if [ $( lsof | grep -c [[:space:]]/mnt/sd/ ) -gt 0 ]; then
  $ksmroot/kbmessage.sh "/mnt/sd/ is busy"
  exit
fi

versionfilename=/mnt/onboard/.kobo/version
#PRODUCT_ID is already exported by ksmhome.sh
VERSION=$(awk -F"," '{print $3}' $versionfilename)
SN=$(awk -F"," '{print $1}' $versionfilename)
VENDOR_ID=0x2237

# just in case one of the variables is empty
PRODUCT_ID=${PRODUCT_ID:-"0x4163"}
VERSION=${VERSION:-"0.0.0"}
SN=${SN:-"N000000000000"}

MODULE_LOADED=`lsmod | grep -c g_file_storage`

if [ $(blkid | grep -c "TYPE=") -gt 0 ]; then
  LUNS=`blkid | tac | grep -v EFI | grep "TYPE=\"vfat\"" | cut -d':' -f1 | xargs | sed -e 's/ /,/'`
else
  if [ -e /dev/mmcblk1p1 ]; then
    LUNS=/dev/mmcblk0p3,/dev/mmcblk1p1
  else
    LUNS=/dev/mmcblk0p3
  fi
fi

PARAMS="vendor=$VENDOR_ID product=$PRODUCT_ID vendor_id=Kobo product_id=eReader-$VERSION SN=$SN"
sync
echo 3 > /proc/sys/vm/drop_caches
umount -l /mnt/onboard
umount -l /mnt/sd

/sbin/insmod /drivers/$PLATFORM/usb/gadget/arcotg_udc.ko
sleep 2

/sbin/insmod /drivers/$PLATFORM/usb/gadget/g_file_storage.ko file=$LUNS stall=1 removable=1 $PARAMS
sleep 1
